import { DoBootstrap, Injector, NgModule, ProviderToken } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { bootstrapCrtModule, CrtModule } from '@creatio-devkit/common';
import { ConcatConverter, CONCAT_SEPARATOR_TOKEN } from './concat.converter';

@CrtModule({
  /* Specify that component is a view element. */
  viewElements: [],
  /* Specify that ConcatConverter is a converter. */
  converters: [ConcatConverter]
})
@NgModule({
  declarations: [],
  imports: [BrowserModule],
  providers: [
    {
      provide: CONCAT_SEPARATOR_TOKEN,
      useValue: ' '
    },
  ],
})
export class AppModule implements DoBootstrap {
  constructor(private _injector: Injector) {}

  ngDoBootstrap(): void {
    /* Bootstrap CrtModule definitions. */
    bootstrapCrtModule('sdk_remote_module_package', AppModule, {
      resolveDependency: (token) => this._injector.get(<ProviderToken<unknown>>token)
    });
  }
}