/* Import the required functionality from the libraries. */
import { InjectionToken } from "@angular/core";
import { Converter, CrtConverter, CrtInject, ViewModelContext } from "@creatio-devkit/common";

/* The CONCAT_SEPARATOR_TOKEN token to work with Angular DI (dependency injection). */
export const CONCAT_SEPARATOR_TOKEN = new InjectionToken<string>('CONCAT_SEPARATOR_TOKEN');

/* Add the CrtConverter decorator to the ConcatConverter interface. */
@CrtConverter({
  type: 'usr.ConcatConverter',
})

export class ConcatConverter implements Converter<string, string> {
  constructor(@CrtInject(CONCAT_SEPARATOR_TOKEN) private _separator: string) { };
  
  /* Implement the convert() method. */
  public convert(value: string, context: ViewModelContext, ...params: string[]): string {
    return [value, ...params].join(this._separator);
  }
}
